'''
Created on 13 May 2024 @author: vnc-console
'''
import unittest
import os
import datetime
import pandas as pd
from jinja2 import (Environment, PackageLoader)

from py_mentor_imports import (Monetar, convert_date_format, get_last_month)


class Test(unittest.TestCase):

    templates = Environment(loader=PackageLoader('py_mentor_imports', 'templates'))
    template = templates.get_template('monetars.txt')

    def test_monet(self):
        path = r'f:\Gdrive\Misc\Dosar-Contabilitate\Ridewave\2024_04\raport_z\20240507213946_from_010424_to_300424__from_5_to_29.xlsx'
        df = pd.read_excel(path)
        df = df.drop(['Unnamed: 1', 'Unnamed: 2', 'Unnamed: 3',
                      'Unnamed: 5', 'Unnamed: 6', 'Unnamed: 7',
                      'Unnamed: 9', 'Unnamed: 11', 'Unnamed: 13'], axis=1)
        df['4. Data raport Z'] = df['4. Data raport Z'].apply(convert_date_format)
        # print(df['4. Data raport Z'])
        monetars = []
        for zi, date, number, value in zip(df['1. Zi fiscala'], df['4. Data raport Z'], df['5. Numar\nbonuri'], df['6. Valoare\ntotala']):
            monetar = Monetar(zi_fiscala=zi, data_raport_z=date, numar_bonuri=number, value=value)
            monetars.append(monetar)

        data = {'AnLucru': datetime.date.today().year,
                'LunaLucru': get_last_month(1),
                'TotalMonetare': len(df),
                'documents': monetars,
                # 'NrDoc': [],
                # 'NumarBonuri': [],
                # 'Data': [],
                # 'Observatii': [],
                'Code': 'TRANSPMF'
                # 'Pret': []
                }

        output = self.template.render(data)
        print(output)
        home = os.path.expanduser('~')
        downloads_dir = os.path.join(home, 'Downloads', 'mentor', 'import', 'RIDEWAVE')
        output_file = os.path.join(downloads_dir, 'monetare.txt')
        with open(output_file, 'w') as text:
            text.write(output)


if __name__ == "__main__":
    Test().test_monet()
    # unittest.main()
